#
# Makefile Template for Tessy
#
# Compiler: ARM Ltd - RVDS 3.0
# Debugger: Keil Vision
# Template Version : 1.2
#

# Defines to be generated by Tessy:
#
# TESSY_SYS          :=
# MODULE_PATH        :=
# TESTOBJECT         :=
# USER_LINK_OPTIONS  :=
# COMPILER_INSTALL_PATH :=
# TARGET_INSTALL_PATH   :=

#####################################################################
#BEGIN_DEFINES
#####################################################################

TESSY_SYS_DOS   := $(shell ts_pathname -s $(TESSY_SYS))
MODULE_PATH_DOS := $(shell ts_pathname -s $(MODULE_PATH))
ARM_HOME        := $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)')
ARM_DLLS        := $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)/../RV31/LIB')
ARM_HEADER      := $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)/../RV31/INC')
ARM_INC         := $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)/../INC/ST/STM32F10x')
#DEVICE          := DARMSTM
UVSC_HOME       := $(shell ts_pathname -s '$(TARGET_INSTALL_PATH)')

TS_NAME         := TS_UVISION
IDE_NAME        := uvision_uvsc
COMPANY_NAME    := keil
PROCESSOR_NAME  := arm_rvds

all    : master slave
master : $(MODULE_PATH)/ts_$(TESTOBJECT)_m.exe
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX)


#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE    := $(TESSY_SYS)/make/master_$(IDE_NAME)_gnu_i386.mk
S_COMM_MAKE    := $(TESSY_SYS)/src/comm/comm_$(IDE_NAME)_$(PROCESSOR_NAME).mk


#
# SLAVE
# (You may change these settings to use your own compiler/linker options)
#
S_COMP_OPTIONS := --thumb --device $(DEVICE) -g -O0 --apcs=interwork -I $(ARM_INC) \
                  -I $(ARM_HEADER) -DTESSY -DTS_SLAVE -DTS_RVDS_ARM -DTS_ARM -DTS_HAVE_FLOAT64 \
                  -DTS_HAVE___int64 -D__MICROLIB
S_LINK_OPTIONS := --library_type=microlib --device $(DEVICE) --scatter $(SCATTER_FILE) --autoat --libpath $(ARM_DLLS)
S_INCLUDES     := -I$(TESSY_SYS_DOS)\include\tessy\comm -I$(MODULE_PATH_DOS)

S_CC           := $(ARM_HOME)\armcc.exe
S_ASM          := $(ARM_HOME)\armasm.exe
S_LINK         := $(ARM_HOME)\armlink.exe
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs$(OBJECT_POSTFIX)
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr$(OBJECT_POSTFIX)



#####################################################################
#END_DEFINES
#####################################################################

# Targets to be defined by Tessy
#
# for each source
#
# S_SRC_OBJECTS      := $(MODULE_PATH)/ts_src01$(OBJECT_POSTFIX) ... ts_srcnn$(OBJECT_POSTFIX)
# USER_COMP_OPTIONS* :=
#
# $(MODULE_PATH_DOS)\ts_src*$(OBJECT_POSTFIX) : $(MODULE_PATH_DOS)\ts_src*.c
#     $(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $(USER_COMP_OPTIONS*) -c $< -o $@

#####################################################################
#BEGIN_TARGETS
#####################################################################


#
# COMPILE USERCODE / STUBS
#
$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	@echo ***** Compiling Usercode *****
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) -o $@ -c $<

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	@echo ***** Compiling Stubs *****
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) -o $@ -c $<

#
# COMPILE/LINK MASTER
#

include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES

include $(S_COMM_MAKE)



#
# COMPILE/LINK SLAVE
#
$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJECT_POSTFIX) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@echo *
	@echo ***** Compiling Slave *****
	$(S_CC) $(S_COMP_OPTIONS) $(S_INCLUDES) -o $@ -c $<

$(MODULE_PATH_DOS)\Startup.o: $(STARTUP_FILE)
	$(S_ASM) --device $(DEVICE) -g --apcs=interwork --pd "__MICROLIB SETA 1" -I $(ARM_INC) -o "$@" "$<"

$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(BINARY_POSTFIX) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJECT_POSTFIX) \
									$(S_SRC_OBJECTS) \
									$(S_UC_OBJECT) \
									$(S_STUB_OBJECT) \
									$(S_OBJECTS) \
									$(MODULE_PATH_DOS)\Startup.o

	@echo *
	@echo ***** Linking Slave *****

	$(S_LINK) $(S_LINK_OPTIONS) $(USER_LINK_OPTIONS) --output $@ $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJECT_POSTFIX) \
   $(S_SRC_OBJECTS) $(S_UC_OBJECT) $(S_STUB_OBJECT) $(S_OBJECTS) $(MODULE_PATH_DOS)\Startup.o
	@-ts_rm "$(MODULE_PATH)"/*$(OBJECT_POSTFIX)


#####################################################################
#END_TARGETS
#####################################################################












